#!/bin/sh

clear

# add UUID below for auto mount
UUID="";

if [[ $UUID != "" ]]; then

	diskutil mount $UUID
	echo "Done."

else

	containsElement () {

		local e
		for e in "${@:2}"; do
			[[ "$e" == "$1" ]] && return 0;
			done
		return 1

	}

	echo "Searching for hidden EFI Partitions..."
	echo

	partitions=()

	for volume in /dev/disk*; do

		identifier=${volume#/dev/}
		name=$(diskutil info $identifier | grep "Device / Media Name:" | awk '{print $5}')
		vname=$(diskutil info $identifier | grep "Volume Name:" | awk '{print $3}')
		type=$(diskutil info $identifier | grep "Partition Type:" | awk '{print $3}')
		size=$(diskutil info $identifier | grep "Total Size:" | awk '{print $3}')
		if [[ ( $type == "EFI" && $name == $type && $vname != $type && $size > 200 ) ]]; then

			partitions+=($identifier)
			echo "$identifier"

		fi

	done

	if [ ${#partitions[@]} == 0 ]; then

		echo "Found no Partitions."
		echo

	elif [ ${#partitions[@]} == 1 ]; then

		echo "Found ${#partitions[@]} Partition."
		echo

		diskutil mount ${partitions[0]}
		echo "Done."

	else

		echo "Found ${#partitions[@]} Partitions."
		echo

		while [ 1 ]; do

			read -p "Please enter disk identifier to continue: " input
			if [[ $input == "" ]]; then

				echo "Abort."
				break

			else

				containsElement $input "${partitions[@]}"
				if [[ $? == 0 ]]; then

					diskutil mount $input
					echo "Done."
					break

				else

					echo "Couldn’t mount \"$input\". Please check your input again!"
					echo

				fi

			fi

		done

	fi

fi